"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    FinalNewLinePlugin: function() {
        return FinalNewLinePlugin;
    },
    default: function() {
        return _default;
    }
});
const _define_property = require("@swc/helpers/_/_define_property");
const _state = require("@codemirror/state");
const _view = require("@codemirror/view");
let FinalNewLinePlugin = class FinalNewLinePlugin {
    ensureFinalNewLine(newLine = false) {
        const endLine = this.view.state.doc.line(this.view.state.doc.lines);
        if (endLine.length) {
            const hasSelection = this.view.state.selection.ranges.some((range)=>range.from !== range.to);
            this.view.dispatch({
                changes: {
                    from: endLine.to,
                    insert: _state.Text.of([
                        '',
                        ''
                    ])
                },
                selection: newLine && !hasSelection ? {
                    anchor: endLine.to + 1,
                    head: endLine.to + 1
                } : undefined
            });
        }
    }
    update(update) {
        if (update.focusChanged) {
            setTimeout(()=>{
                this.ensureFinalNewLine();
            }, 0);
        }
    }
    constructor(view){
        _define_property._(this, "view", void 0);
        this.view = view;
        setTimeout(()=>{
            this.ensureFinalNewLine(true);
        }, 0);
    }
};
const plugin = _view.ViewPlugin.fromClass(FinalNewLinePlugin);
const _default = plugin;
